function _instanceof(b, a) {
    if (a != null && typeof Symbol !== "undefined" && a[Symbol.hasInstance]) {
        return !!a[Symbol.hasInstance](b)
    } else {
        return b instanceof a
    }
}
function _classCallCheck(a, b) {
    if (!_instanceof(a, b)) {
        throw new TypeError("Cannot call a class as a function")
    }
}
function _defineProperties(d, b) {
    for (var a = 0; a < b.length; a++) {
        var c = b[a];
        c.enumerable = c.enumerable || false;
        c.configurable = true;
        if ("value"in c) {
            c.writable = true
        }
        Object.defineProperty(d, c.key, c)
    }
}
function _createClass(c, a, b) {
    if (a) {
        _defineProperties(c.prototype, a)
    }
    if (b) {
        _defineProperties(c, b)
    }
    return c
}
var DM78JsSDK = (function() {
    function b() {
        _classCallCheck(this, b);
        this.callbacks = {}           //this.callbacks 是保存回调的 map, key 是回调的标识名(由 dm-js:// + url + searchParams 组成, 为 dm-js), value 是回调函数
    }
    _createClass(b, [{
        key: "sendRequest",           //js 代码来调用 sendRequest
        value: function c(obj) {
            var url = obj.url
              , params = obj.params
              , success_func = obj.success
              , error_func = obj.error;
            var result_link = "dm-js://" + url;
            if (params) {
                result_link = result_link + "?" + this.encodeSearchParams(params)
            }
            this.callbacks[result_link] = {
                success: success_func,
                error: error_func
            };
            var iFrameEle = document.createElement("iframe"); //开启一个 1px 的 iframe，让原生拦截，从而实现 js 到原生的通讯
            iFrameEle.style.width = "1px";
            iFrameEle.style.height = "1px";
            iFrameEle.style.display = "none";
            iFrameEle.src = result_link;
            document.body.appendChild(iFrameEle);
            setTimeout(function() {
                iFrameEle.remove()
            }, 100)
        }
    }, {
        key: "handleRequest",           //原生代码来调用 handleRequest
        value: function e(obj) {
            var url = obj.url
              , data = obj.data
              , error = obj.error;
            var callback = this.callbacks[url];
            if (callback != null) {
                if (data != null && callback.success != null) {
                    callback.success(data)
                } else {
                    if (error != null && callback.error != null) {
                        callback.error(error)
                    }
                }
                delete this.callbacks[url]
            }
        }
    }, {
        // 获取授权信息
        // 返回用户的 Token
        key: "getToken",
        value: function f(obj) {
            var id = obj.id
              , success_func = obj.success
              , error_func = obj.error;
            this.sendRequest({
                url: "getToken",
                params: {
                    app_id: id
                },
                success: success_func,
                error: error_func
            })
        }
    }, {
        // 获取用户信息（蛋趣联合登录）
        key: "getUserInfo",
        value: function d(obj) {
            var id = obj.id
              , success_func = obj.success
              , error_func = obj.error;
            this.sendRequest({
                url: "getUserInfo",
                params: {
                    app_id: id
                },
                success: success_func,
                error: error_func
            })
        }
    },{
        // 获取手机的器件信息
        // 版本号，host，app 版本信息, safeAreaBottom
        key: "getDeviceInfo",
        value: function m(obj) {
            var success_func = obj.success
            , error_func = obj.error;
            this.sendRequest({
                url: "getDeviceInfo",
                success: success_func,
                error: error_func
            })
        }
    }, {   
        // 打开搜索页面: 
        // keyword: 搜索关键字      
        // type: 搜索类型，默认是 "post"    
        // case post       //:帖子(默认)；
        // case news       //:新闻；
        // case recommend  //:好帖推荐；
        // case review     //:评测；
        // case item       //:单品；
        // case series     //:系列；
        // case factory    //:厂商；
        // case user       //:用户
        key: "openSearchPage",
        value: function m(obj) {
            var success_func = obj.success
            , keyword = obj.keyword
            , type = obj.type
            , error_func = obj.error;
            this.sendRequest({
                url: "openSearchPage",
                params: {
                    type: type,
                    keyword: keyword
                },
                success: success_func,
                error: error_func
            })
        }
    }, {
        // 评分 
        /// score 现在的分数
        /// cid 词条id
        key: "openAddScorePage",
        value: function m(obj) {
            var success_func = obj.success
            , cid = obj.cid
            , score = obj.score
            , error_func = obj.error;
            this.sendRequest({
                url: "openAddScorePage",
                params: {
                    cid: cid,
                    score: score
                },
                success: success_func,
                error: error_func
            })
        }

    }, {       
        /// 词条评论  
        /// cid 词条id
        /// pid 评论id  
        key: "openAddCTCommentPage",
        value: function m(obj) {
            var success_func = obj.success
            , cid = obj.cid
            , pid = obj.pid
            , score = obj.score
            , error_func = obj.error;
            this.sendRequest({
                url: "openAddCTCommentPage",
                params: {
                    cid: cid,
                    pid: pid,
                    score: score
                },
                success: success_func,
                error: error_func
            })
        }

    }, {
        // 打开词条详情页页面: 
        // id: 词条id
        // type: 厂商factory; 单品item; 系列series
        key: "openCtDetailPage",
        value: function m(obj) {
            var success_func = obj.success
            , id = obj.id
            , type = obj.type
            , error_func = obj.error;
            this.sendRequest({
                url: "openCtDetailPage",
                params: {
                    id: id,
                    type: type
                },
                success: success_func,
                error: error_func
            })
        }
    }, {
        // 打开基础的原生页面: 
        // 目前支持的页面: 
        // 1:用户详情页面(type: 'uid')，
        // 2:帖子详情页面(type: 'tid')，
        key: "openBaseNativePage",
        value: function m(obj) {
            var success_func = obj.success
            , id = obj.id
            , type = obj.type
            , error_func = obj.error;
            this.sendRequest({
                url: "openBaseNativePage",
                params: {
                    id: id,
                    type: type
                },
                success: success_func,
                error: error_func
            })
        }
    }, {
        // 获取页面信息,
        // type: 厂商factory; 单品item; 系列series
        key: "getPageInfo",
        value: function m(obj) {
            var success_func = obj.success
            , error_func = obj.error;
            this.sendRequest({
                url: "getPageInfo", 
                success: success_func,
                error: error_func
            })
        }
    }, {
        // 跳转小程序
        key: "jumpMiniprogram",
        value: function m(obj) {
            var success_func = obj.success
            , path = obj.path
            , error_func = obj.error;
            this.sendRequest({
                url: "jumpMiniprogram",
                params: {
                    path: path
                },
                success: success_func,
                error: error_func
            })
        }
    }, {
        // 执行命令
        // reloadWebView: 重新加载 webview 
        // login: 重新登录
        key: "executeCommand",
        value: function m(obj) {
            var success_func = obj.success
            , cmd = obj.cmd
            , error_func = obj.error;
            this.sendRequest({
                url: "executeCommand",
                params: { 
                    cmd: cmd
                },
                success: success_func,
                error: error_func
            })
        }
    }, { 
        // 分享数据
        key: "shareContent",
        value: function m(obj) {
            var success_func = obj.success
            , coverURL = obj.coverURL
            , webURL = obj.webURL
            , title = obj.title
            , description = obj.description
            , error_func = obj.error;
            this.sendRequest({
                url: "shareContent",
                params: { 
                    coverURL: coverURL,
                    webURL: webURL,
                    title: title,
                    description: description
                },
                success: success_func,
                error: error_func
            })
        }
    }, {                        
        // 打开图片浏览器
        // 参数：url 当前打开图片的 url； index: 当前url在所有图片中的索引。
        // 通过
        key: "openPhotoBrowser",
        value: function m(obj) {
            var success_func = obj.success
            , urls = obj.urls
            , index = obj.index
            , error_func = obj.error;
            this.sendRequest({
                url: "openPhotoBrowser",
                params: {
                    urls: urls,
                    index: index
                },
                success: success_func,
                error: error_func
            })
        }
    }, {
        key: "encodeSearchParams",
        value: function a(obj) {
            var h = [];
            Object.keys(obj).forEach(function(i) {
                var j = obj[i];
                if (typeof j === "undefined") {
                    j = ""
                }
                h.push([i, encodeURIComponent(j)].join("="))
            });
            return h.join("&")
        }
    }]);
    return b
}
)();
var DMSDK = new DM78JsSDK();

